Attribute VB_Name = "modNapX"
Option Explicit

Public starttime As Single

Public Function CheckDir(strDir As String) As String
    If Right(strDir, 1) <> "\" Then strDir = strDir & "\"
    CheckDir = strDir
End Function

Function IPToString(IP As Long) As String
    Dim Bytes(4) As Integer

    Bytes(1) = Fix(IP / (256 ^ 3 / 2))
    Bytes(2) = Fix(IP Mod (256 ^ 3 / 2)) / (256 ^ 2) / 2
    Bytes(3) = Fix(Fix(IP Mod (256 ^ 3 / 2)) Mod (256 ^ 2 / 2) / 256 / 2)
    Bytes(4) = IP Mod 256
    
    IPToString = CStr(Bytes(1)) & "." & CStr(Bytes(2)) & "." & _
                 CStr(Bytes(3)) & "." & CStr(Bytes(4))
End Function

Function DoubleToLong(dblValue As Double) As Long
    If dblValue <= 2147483647 Then
        DoubleToLong = dblValue
    Else
        DoubleToLong = -(4294967296# - dblValue)
    End If
End Function

Public Function decodelongipaddr(ByVal longipaddr As String) As String
    Dim HIWORD!, LOWORD!, Nibble_1, Nibble_2, Nibble_3, Nibble_4, IPAddr As String
    HIWORD! = Int(longipaddr / 65536)
    LOWORD! = longipaddr - HIWORD! * 65536
    Nibble_1 = Int(HIWORD! / 256)
    Nibble_2 = HIWORD! - Nibble_1 * 256
    Nibble_3 = Int(LOWORD! / 256)
    Nibble_4 = LOWORD! - Nibble_3 * 256
    IPAddr = Trim(Str(Nibble_4)) & "."
    IPAddr = IPAddr & Trim(Str(Nibble_3)) & "."
    IPAddr = IPAddr & Trim(Str(Nibble_2)) & "."
    IPAddr = IPAddr & Trim(Str(Nibble_1))
    decodelongipaddr = IPAddr
End Function

Public Function FilePart(strPathFileName As String) As String
    FilePart = Mid(strPathFileName, InStrRev(strPathFileName, "\") + 1)
End Function

Public Function ValidFilename(ByVal strFilename As String) As String
'strFileName does not include path
'returns a valid filename; invalid characters are replaced with 'X'
'0-32:" 34 * 42 . 46 / 47 : 58 < 60 > 62 ? 63 \ 92 | 124 129 141-144 157 158
    
    Dim i As Integer
    Dim strChr As String * 1
    
    For i = 1 To Len(strFilename)
        strChr = Mid(strFilename, i, 1)
        
        Select Case Asc(strChr)
        
        Case 0 To 31
            strChr = "X"
        Case 32
            If i = 1 Then strChr = "X" 'space not valid for start of filename
        Case 46
            If i = 1 Then strChr = "X." ' need at least one char before extension
        Case 34, 42, 47, 58, 60, 62, 63, 92, 124, 129, 141 To 144, 157, 158
            strChr = "X"
        End Select
        
        Mid(strFilename, i, 1) = strChr
    Next i
        
    ValidFilename = strFilename
End Function

